c EXAMPLE OF OUTPUT (looks better if you choose IBM PC line graphics):
 
c      /---------------- subroutine a(x)             |   1
c      |/--------------- do i=1,5                    |   2
c      ||/---------------- if(i/2*2.eq.i)then        |   3
c      |||                   x=x*i                   |   4
c      ||+---------------- else                      |   5
c      |||                   x=x/i                   |   6
c      ||\---------------- endif                     |   7
c      |\--------------- enddo                       |   8
c      \---------------- end                         |   9
 
c Diagrams FORTRAN if-else-elseif-endif, do-enddo and case constructs,
c  start and end of routines, type definitions, modules and interfaces;
c  puts a * next to goto, return, cycle, exit, stop, end= and err=.
c It places = next to lines with only comments.
 
c Designed by mitch grunes, in his own time.
 
c Program by Mitchell R Grunes.
c Revision date: 6/17/20.
c If you find it useful, or find a problem, please send me e-mail.
 
c -----------------------------------------------------
c It is VERY IMPORTANT that you select the right FORTRAN
c format.  In CARD format, a C in column 1 marks a
c comment, and anything in column 6 marks a continuation
c line.  That is not true in FREE format.  Most traditional
c FORTRAN code is in card format.
c -----------------------------------------------------
c This program was written in FORTRAN, for historic reasons.
c This was written in Fortran 77 (with common extensions) for
c  portability.  It should also compile under Fortran 90 and Fortran 95,
c  provided you tell the compiler it is in card format.
c---------------------------------------------------------------------
 
c It can be confused if an INCLUDE block contains a structure that
c  begins inside and ends outside (or vice-versa).
 
c I hope this works for you, but bear in mind that nothing short of
c  a full-fledged language parser could really do the job.  Perhaps
c  worth about what you paid for it.    (-:
 
c There are procedures to run this from a command line, and there are
c versions for Fortran (card and free formats),IDL, PV-WAVE, GDL, FL,
c C, C++, HTML and XML.
c See http://mgrunes.com/diagram/index.html for more info.
 
c-----------------------------------------------------------------------
        function LenA(a)                        ! Length of string, at least 1
c Program by Mitchell R Grunes.
c Revision date: 5/15/2017.
        character*(*) a
        n=len(a)
        dowhile(n.gt.1.and.a(n:n).eq.' ')
          n=n-1
        enddo
        LenA=n
        end
c-----------------------------------------------------------------------
        function iRd(a,iDefault)                ! Read prompted integer from stdin.
                                                ! if user enters "/", pick iDefault.
                                                ! Echo result to standard output.
c Program by Mitchell R Grunes.
c Revision date: 5/15/2017.
        character*(*) a
        print*,a(1:lenA(a))//':'
        i=iDefault
        read*,i
        print*,i
        iRd=i
        end
c-----------------------------------------------------------------------
        character*5000 function aRd(a)          ! Read prompted string from stdin.
                                                ! Echo result to standard output.
                                                ! Used for filenames.
c Program by Mitchell R Grunes.
c Revision date: 5/15/2017.
        character*(*)  a
        character*5000 b
        print*,a(1:len(a))//':'
        b=' '
        read(*,'(100(100a1))')(b(i:i),i=1,5000)
        print*,b(1:lenA(b))
        aRd=b
        end
c-----------------------------------------------------------------------
        subroutine Warn(Message,form,fout,a)            ! Issue a warning
c Program by Mitchell R Grunes.
c Revision date: 6/17/2020.
        character*(*) Message
        character*(*) form
        logical fout
        character*5000 a
        if(fout)write(2,*)'***WARNING ',Message,': Line ',
     &   form(1:lenA(form)),':'
                print*,   '***WARNING ',Message,': Line ',
     &   form(1:lenA(form)),':'
        if(fout)print*,a(1:LenA(a))
        print*,char(7)
        end
c-----------------------------------------------------------------------
        subroutine Errr(Message,form,fout,a)            ! Issue an error
c Program by Mitchell R Grunes.
c Revision date: 6/17/2020.
        character*(*) Message
        character*(*) form
        logical fout
        character*5000 a
        if(fout)write(2,*)'***ERROR ',Message,': Line ',
     &   form(1:lenA(form)),':'
                print*,   '***ERROR ',Message,': Line ',
     &   form(1:lenA(form)),':'
        if(fout)print*,a(1:LenA(a))
        print*,char(7)
        end
c-----------------------------------------------------------------------
        logical function find(a,b,icond,jcol)   ! find b in a, subject
                                                !  to conditions:
                                                ! Column is prior to jcol
                                                !  (if jcol.ne.0)
                                                ! icond=sum of the
                                                !  following:
                                                ! 1:  Prior, if exists, must
                                                !     be blank
                                                ! 2:  Must be first non-blank
                                                ! 4:  Prior character, if
                                                !  present, must not be
                                                !  alphanumeric.
                                                ! 8:  Prior character, if
                                                !  present, must be blank
                                                !  or )
                                                ! 16: Prior character, if
                                                !  present, must be blank
                                                !  or ,
                                                ! 32: Next character not
                                                !  alphanumeric
                                                ! 64: Next character not
                                                !  alphabetic
                                                ! 128:Next character must
                                                !  be blank or (
                                                ! 256:1st non-blank,
                                                !  possibly except for
                                                !  numeric labels
                                                ! 512  Prior character, if present,
                                                !      must be blank or ) or }
                                                !      or { or ;
 
C Caution: This program varies from one main program to the next.
 
c Program by Mitchell R Grunes.
c Revision date: 5/15/2017.
        character*(*) a,b
        character*1   c,cNext,c2
        common iCol,iCol1
        logical result
 
        ii=len(a)
        jj=len(b)
        result=.false.
        jjcol=1e9
        if(jcol.gt.0)jjcol=jcol
        do i=1,min(ii-jj+1,jjcol)
          if(a(i:i+jj-1).eq.b)then              ! Found--Now do tests
            iCol1=i                             ! iCol1=column of item
                                                !  found
            iCol =i+jj                          ! iCol =column after
                                                !  item found
 
            c=' '
            cNext=' '
            if(iCol1.gt.1)c=a(iCol1-1:iCol1-1)
            if(iCol .le.ii)cNext=a(iCol:iCol)
 
            result=.true.
            if(result.and.iand(icond,1).ne.0.and.icol1.gt.1)then
              result=c.eq.' '
            endif
 
            if(result.and.iand(icond,2).ne.0.and.iCol1.gt.1)then
              result=a(1:iCol1-1).eq.' '
            endif
 
            if(result.and.iand(icond,4).ne.0)
     &       result=(c.lt.'0'.or.c.gt.'9').and.(c.lt.'a'.or.c.gt.'z')
            if(result.and.iand(icond,8).ne.0)result=c.eq.' '.or.c.eq.')'
 
            if(result.and.iand(icond,16).ne.0)
     &       result=c.eq.' '.or.c.eq.','
 
            if(result.and.iand(icond,32).ne.0)
     &       result=(cNext.lt.'0'.or.cNext.gt.'9').and.
     &              (cNext.lt.'a'.or.cNext.gt.'z')
 
            if(result.and.iand(icond,64).ne.0)
     &       result=(cNext.lt.'a'.or.cNext.gt.'z')
 
            if(result.and.iand(icond,128).ne.0)
     &       result=cNext.eq.' '.or.cNext.eq.'('
 
            if(result.and.iand(icond,256).ne.0.and.iCol1.gt.1)then
              do iii=1,iCol1-1
                c2=a(iii:iii)
                if((c2.lt.'0'.or.c2.gt.'9').and.c2.ne.' ')result=.false.
              enddo
            endif
 
            if(result.and.iand(icond,512).ne.0)result=c.eq.' '
     &       .or.c.eq.';'.or.c.eq.')'.or.c.eq.'{'.or.c.eq.'}'
 
            find=result
            if(result)return
          endif
        enddo
        find=result
        end
c-----------------------------------------------------------------------
        Function iRdLin(iUnit,fOut,MaxL,a,nLine,form)! Read line from input file...
                                                ! Function returns Returns non-zero
                                                !  at end of file.
                                                ! Handle form feeds, expand tabs,
                                                !  and drop non-ascii characters.
        ! --- Inputs --
        integer iUnit                           ! File unit #
        logical fOut                            ! .true. if outputing to a file.
        integer MaxL                            ! Length over which should issue warning.
        ! --- Outputs --
        character*5000 a                        ! The output line.
        character*5    form                     ! Output formatted line #.
        ! --- Input and Output ---
        integer nLine                           ! Line number -- incremented
 
c Program by Mitchell R Grunes.
c Revision date: 5/15/2017.
 
        character*5000 b
 
        a=' '
        read(iUnit,'(100(100a1))',end=99)(a(i:i),i=1,5000)
        nLine=nLine+1
 
        b=' '                                   ! Format line #
        write(b,'(i5)')nLine
        form=b
 
        if(a(1:1).eq.char(12))then
          if(fout)write(2,'(a1,:)')char(12)
          if(.not.fout)print*,'------------FORM FEED------------'
          a=a(2:5000)
        endif
 
        b=' '                                   ! Expand tabs to spaces,
                                                ! Drop non-ascii characters.
        i2Long=0                                ! not yet marked too long
        iLong=0                                 ! not yet marked long
        j=1                                     ! Output Column #
        do i=1,LenA(a)
          if(a(i:i).eq.char(9))then             ! char(9) is tab
            j=(j-1)/8*8+8+1
                                                ! Ascii printable characters
                                                ! are between ' ' and char(128)
          elseif(a(i:i).ge.' '.and.a(i:i).lt.char(128))then
            if(j.le.5000)b(j:j)=a(i:i)
            j=j+1
            if(a(i:i).ne.' '.and.j.ge.5000-10.and.i2Long.eq.0)then
              call Warn('Line too long to diagram',form,fout,a)
              i2Long=1
            elseif(a(i:i).ne.' '.and.j.gt.MaxL.and.iLong.eq.0)then
              call Warn('Line over warning length',form,fout,a)
              iLong=1
            endif

          endif
        enddo
        a=b
 
        iRdLin=0
        return
 
99      iRdLin=1
        end
c-----------------------------------------------------------------------
                                                ! Format Output Line
        subroutine FormLine(b,fout,nColPre,i1,i2,i3,i4,
     &   i1pp,i2pp,i3pp,i4pp,igoto,LCol,form,icomment,icomment2,
     &   icomment3,iGraphics)

c Program by Mitchell R Grunes.
c Revision date: 11/22/2017.

        implicit none
 
        ! --- Inputs (some may actually be modified) --
        character*5000 b                        ! Source code Line being output
        logical fout                            ! Outputing to file (unit 2)?
        integer nColPre                         ! # of cols used to diagram preprocessor directives; 0=none.
                                                !   12 for diagramc; 0 for diagramf, diagramh, diagrami.
        integer i1                              ! # of nest levels before current line
        integer i2                              ! # of nest levels on current line
        integer i3                              ! # of nest levels after current line
        integer i4                              ! Non 0 if start or end of block
        integer i1pp,i2pp,i3pp,i4pp             ! Similar to above for preprocessor
        integer igoto                           ! non 0 if there is a goto in line
        integer LCol                            ! Column in which to write line #'s; 0=none
        character*5 form                        ! Formatted line #

        integer icomment                        ! Non 0 if inside comment.
        integer icomment2                       ! Is there anything outside comment?
        integer icomment3                       ! Did a comment occur?

        ! --- Input and Output ---
        integer iGraphics                       ! Non-0 to use IBM PC graphics characters

        ! --- Internal ---

        integer iBlock                          ! Index into Block begin array (1=single line, 2=double)
        integer nColLin                         ! # of cols available to diagram,
                                                ! including preprocessor stuff=12.

        external LenA
        integer  LenA

        ! Symbols which will mark block actions:
        character*1 BlockBegin    (2) /'/','/'/ ! Start of block
        character*1 BlockEnd      (2) /'\','\'/ ! End of block
        character*1 BlockElse     (2) /'+','+'/ ! Else construct
        character*1 BlockContinue (2) /'|','|'/ ! Block continues w/o change
        character*1 BlockHoriz    (2) /'-','-'/ ! Horizontal to start of line

        ! Same as above, but allows horizontal line to continue through:
        character*1 BlockBeginH   (2) /'/','/'/ ! Start of block
        character*1 BlockEndH     (2) /'\','\'/ ! End of block
        character*1 BlockElseH    (2) /'+','+'/ ! Else construct

        character*5000 a                        ! formatted output line
        integer n,i,j,LastUse
        character*1 c

        if(iGraphics.ne.0)then
          iGraphics=1
 
          BlockBegin   (1)=char(218)            ! (1)=normal
          BlockEnd     (1)=char(192)
          BlockElse    (1)=char(195)
          BlockContinue(1)=char(179)
          BlockHoriz   (1)=char(196)
          BlockBeginH  (1)=char(194)
          BlockEndH    (1)=char(193)
          BlockElseH   (1)=char(197)
 
          BlockBegin   (2)=char(214)            ! (2)=DO/FOR loops (doubled)
          BlockEnd     (2)=char(211)            ! (not yet used)
          BlockElse    (2)=char(199)
          BlockContinue(2)=char(186)
          BlockHoriz   (2)=char(196)
          BlockBeginH  (2)=char(209)
          BlockEndH    (2)=char(208)
          BlockElseH   (2)=char(215)
        endif

        iBlock=1                                ! Not using doubled lines for now

        nColLin=12

        ! Output Columns                 Usage
        ! --------------                 ------------------------------
        ! 1                              '='=Comment, '*'=jump
        ! 2 to 1+nColPre                 Diagrams preprocessor directives
        ! 2+nColPre to 1+nColLin         Diagrams everything else;
        !                                blank lines at start of code also used.
        ! 2+nColLin to 5000              The Code
        !                                Also continued horizontal lines from 
        !                                above
        ! 1+nColLin+LCol:+nColLin+LCol   If, blank, | and line #

        a=' '
 
        if(i1.lt.0.or.i2.lt.0.or.i3.lt.0.or.i4.lt.0)then
          call Errr('Invalid diagramming index',form,fout,b)
          i1=max(i1,0)
          i2=max(i2,0)
          i3=max(i3,0)
          i4=max(i4,0)
        endif
        i2=max(i1,i3)                           ! Revise i2
        i4=max(i4,iabs(i3-i1))                  ! Fix if i3.gt.i1
 
        a=' '
        a(2+nColLin:5000)=b
 
        if(1+nColLin+LenA(b).gt.5000)
     &   call Warn('Too many columns to diagram',form,fout,b)
 
        if(igoto.ne.0)a(1:1)='*'                ! Place * next to jumps

        if(icomment.ne.0)icomment3=1 
        if(icomment2.ne.1.and.icomment3.ne.0.)a(1:1)='=' ! Place = next to line with only comments

        LastUse=2                               ! Last usable diagram col - includes blank space at start of code
        dowhile(LastUse.lt.5000.and.a(LastUse:LastUse).eq.' ')
          LastUse=LastUse+1
        enddo
        LastUse=LastUse-2                       ! But leave one blank space before.

        if(max(i2,i3).gt.0)then                 ! Draw one vertical line per nest level
          do i=1,max(i2,i3)
            j=i + 1+nColPre
            if(j.le.LastUse) a(j:j)=BlockContinue(iBlock)
          enddo
          if(i4.ne.0)then                       ! Draw horizontal lines inward from above
            do i=j+1,LastUse
              a(i:i)=BlockHoriz(iBlock)
            enddo
          endif
        endif
 
        do i=1,i4                               ! May need to replace some
                                                !  vertical lines with
          c=            BlockElse(iBlock)       !       else  symbol
          if(i1.lt.i3)c=BlockBegin(iBlock)      !  or   begin symbol
          if(i1.gt.i3)c=BlockEnd   (iBlock)     !  or   end   symbol
          j=max(2+nColPre,i2+1-i+1)
          if(j.le.LastUse)then
            a(j:j)=c
            if(a(j+1:j+1).eq.BlockElse  (iBlock)) ! Continue horizontal lines
     &         a(j+1:j+1)  = BlockElseH (iBlock)
            if(a(j+1:j+1).eq.BlockBegin (iBlock))
     &         a(j+1:j+1)  = BlockBeginH(iBlock)
            if(a(j+1:j+1).eq.BlockEnd   (iBlock))
     &         a(j+1:j+1)  = BlockEndH  (iBlock)
          endif
        enddo
        if(nColPre.gt.0)then                    ! Similar for preprocessor
          if(i1pp.lt.0.or.i2pp.lt.0.or.i3pp.lt.0.or.i4pp.lt.0)then
            call Errr('Invalid diagramming index',form,fout,b)
            i1pp=max(i1pp,0)
            i2pp=max(i2pp,0)
            i3pp=max(i3pp,0)
            i4pp=max(i4pp,0)
          endif
          i2pp=max(i1pp,i3pp)                   
          i4pp=max(i4pp,iabs(i3pp-i1pp))        
          LastUse=1+nColPre
 
          if(max(i2pp,i3pp).gt.0)then
            do i=1,max(i2pp,i3pp)
              j=i + 1+nColPre
              if(j.le.LastUse) a(j:j)=BlockContinue(iBlock)
            enddo
            if(i4pp.ne.0)then
              do i=j+1,LastUse
                a(i:i)=BlockHoriz(iBlock)
              enddo
            endif
          endif

          do i=1,i4pp
            c=              BlockElse(iBlock)
            if(i1pp.lt.i3pp)c=BlockBegin(iBlock)
            if(i1pp.gt.i3pp)c=BlockEnd   (iBlock)
            j=max(2+nColPre,i2pp+1-i+1)
            if(j.le.LastUse)then
              a(j:j)=c
              if(a(j+1:j+1).eq.BlockElse  (iBlock))
     &           a(j+1:j+1)  = BlockElseH (iBlock)
              if(a(j+1:j+1).eq.BlockBegin (iBlock))
     &           a(j+1:j+1)  = BlockBeginH(iBlock)
              if(a(j+1:j+1).eq.BlockEnd   (iBlock))
     &           a(j+1:j+1)  = BlockEndH  (iBlock)
            endif
          enddo

        endif

        if(LCol.gt.0.and.a(1+nColLin+LCol:5000).eq.' ')then ! Include line #
          if(form(1:1).eq.' ')form(1:1)=BlockContinue(iBlock)
          a(1+nColLin+LCol:5000)=form
        endif
 
        n=LenA(a)                               ! Output diagrammed line
        if(.not.fout)write(*,'(1x,100(100a1))')(a(i:i),i=1,n)
        if(fout)     write(2,'(100(100a1))')(a(i:i),i=1,n)
        if(.not.fout)write(*,'(100(100a1))')(a(i:i),i=1,n)
 
        i1=i3
        i1pp=i3pp
        return
        end
c-----------------------------------------------------------------------
        program diagramf                        ! Diagrammer for Fortran

c Program by Mitchell R Grunes.
c Revision date: 6/16/20.

        external aRd
        character*5000 FilNam,FilNam2,aRd
 
        FilNam=aRd('FORTRAN source file name')
 
        FilNam2=aRd('Output file (blank=screen)')
 
        LCol=iRd('Column in which to write line #''s '//
     &           '(0 for none; 67 for 80 col screen; '//
     &           '73 shows card format)'//
     &           '133 shows free format)',73)
 
        iembed=iRd('Embed include files (0=no; 1?)',1)
        print*,' '
 
        print*,'-----------------------------------------------------'
        print*,'It is VERY IMPORTANT that you select the right FORTRAN'
        print*,'format.  In CARD format, a C in column 1 marks a'
        print*,'comment, and anything in column 6 marks a continuation'
        print*,'line.  That is not true in FREE format.'
        print*,'--Select Fortran format--'
        print*,'0=Card format (cols 1-6 special, warnings past 72)'
        print*,'1=Free format (nothing special, warnings past 132)'
        print*,'2=Card format, but warnings if anything past 132)'
        iFree=iRd('Format # (0?)',0)
 
        print*,'In addition to warnings on whether non-comment code'
        print*,'goes past that length, we can warn if total line'
        print*,'length goes past some length.'
        MaxL=iRd('Maximum total line length without warning(132?)',132)
 
        iGraphics=iRd('Use IBM PC graphics characters (0=no)',0)
 
        call diagram(FilNam,FilNam2,LCol,iembed,iFree,iGraphics,MaxL)
        end
c-----------------------------------------------------------------------
        subroutine diagram(FilNam,FilNam2,LCol,iembed,iFree,iGraphics,
     &   MaxL)
c Program by Mitchell R Grunes.
c Revision date: 11/22/2017.
        character*5000 FilNam,FilNam2
        character*5000 a,b,AfterSemi
        character*5 form                         ! Formatted line #
        character*8 fm
        character*1 c,c2
        logical find
        external find
        common iCol,iCol1
        character*10 label(100)
        logical fout
 
        open(1,file=FilNam,status='old')
        fout=FilNam2.gt.' '
        if(fout)open(2,file=FilNam2,status='unknown')
                                                ! ASCII 12 is a form feed
        if(fout)write(2,*)char(12),
     &   '=============--',FilNam(1:LenA(FilNam)),'--============='
 
        if(.not.fout)write(*,'(11x,a50,a30,/)'),
     &   '....,....1....,....2....,....3....,....4....,....5',
     &   '....,....6....,....7....,....8'
        if(fout)     write(2,'(11x,a50,a30,/)')  ! Write column header
     &   '....,....1....,....2....,....3....,....4....,....5',
     &   '....,....6....,....7....,....8'
 
        i1=0                                    ! # of nest levels before current line
        i2=0                                    ! # of nest levels on current line
        i3=0                                    ! # of nest levels after current line
        i4=0                                    ! not 0 to flag start or end of block
        InSub=0                                 ! Inside a subroutine,
                                                !  function or mainline
        InMod=0                                 ! Inside module or
                                                !   contains
        nMain=0                                 ! no mainline program yet
        InElse=0                                ! Found elseif, but no then
                                                ! Yet - presumably will on
                                                ! continuation lines
        nlabel=0                                ! # of labels for do loop
                                                !  ends
        iAlphaNum=0                             ! Last char of line is
                                                !  alpha-numeric?
        iContinueOld=0                          ! next line not continued line
        nLine=0
        icomment=0                              ! Not inside comment - since Fortran
                                                ! doesn't have /* and */, is always
                                                ! true

        iunit=1
10      if(iRdLin(iUnit,fOut,MaxL,a,nLine,form).ne.0)goto 99 ! Read line from input file...
        b=a

        icomment2=0                             ! anything outside comment
        icomment3=icomment                      ! no comment occurred
 
c       print*,'b=',b(1:lena(b))        !##
        a=' '                                   ! My Pre-processed output
        j=1                                     ! Pre-processing to kill quoted
                                                ! fields,comments, find continues,
                                                ! changes upper to lower case
        i72flag=0                               ! nothing over column 72 or 132 yet
 
        iOldAlphaNum=iAlphaNum                  ! last line ended in
                                                ! alpha-numeric?
        iAlphaNum=0
        iContinue=iContinueOld                  ! This line continued line?
        if(find(b,'&',2,0))iContinue=1          !  will be changed to 2 after
                                                !  first non/blank.
        if(iContinue.eq.0)then
          iquote=0                              ! no ' yet
          idquote=0                             ! no " yet
        endif
                                                ! comment line?
        if(((b(1:1).eq.'c'.or.b(1:1).eq.'C').and.iFree.ne.1).or.
     &     (b(1:1).eq.'*'.or.b(1:2).eq.'??'))then
          a=' '
          icomment3=1
          goto 15
        endif
 
        do i=1,LenA(b)
          c=b(i:i)
                                                ! handle upper case
          if(c.ge.'A'.and.c.le.'Z')c=char(ichar(c)+32)
 
          if(c.eq.'!'.and.iquote.eq.0.and.idquote.eq.0)then
            icomment3=1
            goto 15
          endif
 
          if(iFree.eq.0.and.i.gt.72 .and.c.ne.' ')then
            if(i72flag.eq.0) then
              call Errr('Past column 72',form,fout,b)
              i72flag=1
            endif
            c=' '
          elseif(iFree.ne.0.and.i.gt.132.and.c.ne.' ')then
            if(i72flag.eq.0)call Errr('Past column 132',form,fout,b)
              i72flag=1
          endif

          if(c.ne.' ')icomment2=1
 
          iquoteold=iquote                       ! Used so quotes are kept
          idquoteold=idquote
 
          if(c.eq.''''.and.(i.ne.6.or.iFree.eq.1).and.idquote.eq.0)
     &     iquote=1-iquote
          if(c.eq.'"' .and.(i.ne.6.or.iFree.eq.1).and.iquote .eq.0)
     &     idquote=1-idquote
          if(iquote.eq.1)then
            if(find(b,'include ',2,0).and.iembed.ne.0)then
              iquote=0
              idquote=0
            endif
          endif
 
                                                ! Blank out quoted fields
          if((iquote.ne.0.or.idquote.ne.0).and.
     &     iquoteold.eq.iquote.and.idquoteold.eq.idquote)c=' '
 
          if(j.gt.1)then                        ! (kill multiple spaces,
                                                !  and spaces around =)
            c2=a(j-1:j-1)
            if(c2.eq.' '.and.c.eq.' ')j=j-1
            if(c2.eq.' '.and.c.eq.'=')j=j-1
            if(c2.eq.'='.and.c.eq.' ')j=j-1
            if(c2.eq.'='.and.c.eq.' ')c='='
          endif
                                                ! Look for
                                                ! identifiers that wrap
                                                ! around lines.
          if((i.gt.6.or.iFree.eq.1).and.c.ne.' '.and.c.ne.'&')then
            iAlphaNum=0
            if((c.ge.'a'.and.c.le.'z').or.
     &       (c.ge.'0'.and.c.le.'9'))then
              iAlphaNum=1
              if(iContinue.eq.1)then
                if(iOldAlphaNum.ne.0)
     &           call Warn('Possible split identifier',form,fout,b)
              endif
            endif
            iContinue=2
          endif
 
          if(j.le.5000)a(j:j)=c
          j=j+1
        enddo
c       print*,'a=',a(1:lena(a))       !##
 
15      if(iQuote.ne.0.or.idquote.ne.0)
     &   call Errr('Unclosed quote',form,fout,b)
                                                ! Possible mainline start
        iContinueOld=0
        if(a(LenA(a):LenA(a)).eq.'&')iContinueOld=1
        i2=i1
        i3=i1
        i4=0
        igoto=0                                 ! no goto on line
        Main1=0                                 ! (Not mainline)
 
16      AfterSemi=' '                           ! Break line at semicolons
        if(find(a,';',0,5000-1))then
          AfterSemi='      '//a(icol:5000)
          a=a(1:icol1-1)
        endif
        if(a.ne.' '.and.InSub.eq.0.and.InMod.eq.0)Main1=1
                                                ! Mark various types of jump
        if(find(a,'go to', 8+64,0).or.find(a,'goto',  8+64,0).or.
     &     find(a,'end=',  16,  0).or.find(a,'err=',  16,  0).or.
     &     find(a,'return',8+64,0).or.find(a,'cycle ',8,   0).or.
     &     find(a,'exit ', 8,   0).or.find(a,'stop ', 8,   0))
     &   igoto=1
 
        if(find(a,')1',    64,  0).or.find(a,')2',    64,  0).or.
     &     find(a,')3',    64,  0).or.find(a,')4',    64,  0).or.
     &     find(a,')5',    64,  0).or.find(a,')6',    64,  0).or.
     &     find(a,')7',    64,  0).or.find(a,')8',    64,  0))
     &   igoto=1
 
        if(find(a,')9',    64,  0)                         .or.
     &     find(a,') 1',   64,  0).or.find(a,') 2', 64,0)  .or.
     &     find(a,') 3',   64,  0).or.find(a,') 4', 64,0)  .or.
     &     find(a,') 5',   64,  0).or.find(a,') 6', 64,0)  .or.
     &     find(a,') 7',   64,  0).or.find(a,') 8', 64,0)  .or.
     &     find(a,') 9',   64,  0))
     &   igoto=1
 
        if(find(a,'::',0,0))then                ! To distinguish
          iDeclare=iCol                         !  declarations from
                                                !  keywords
        else
          iDeclare=999
        endif
 
        if(find(a,'include ''',2,0).and.iembed.ne.0)then
          FilNam=a(iCol:5000)
          if(.not.find(FilNam,'''',0,0))goto 20
          FilNam(iCol-1:5000)=' '
                  print*,'including file ',FilNam(1:50)
          if(fout)print*,'including file ',FilNam(1:50)
          close(3)
          open(3,file=FilNam,status='old',err=17)
          iunit=3
          nLinesave=nLine
          nLine=0
          i2=i2+1
          i3=i3+1
          i4=max(i4,1)
          goto 20
17        call Warn('Missing include file ',form,fout,a)
        elseif(find(a,'end module ',2,0).or.
     &         find(a,'endmodule ',2,0).or.
     &         find(a,'end interface',2,0).or.
     &         find(a,'endinterface',2,0).or.
     &         find(a,'end type ',2,0).or.
     &         find(a,'endtype ',2,0))then
          i3=i3-1
          InMod=InMod-1
          if(find(a,'endmodule ',2,0).or.
     &       find(a,'end module ',2,0))then
            InMod=0
            if(InSub.gt.0.or.i3.ne.0)
     &       call Errr('Invalid diagramming index',form,fout,b)
          endif
        elseif(find(a,'enddo ',256,0).or.
     &         find(a,'end do ',256,0))then
          i3=i3-1
          nlabel=max(0,nlabel-1)
        elseif(find(a,'endif  ',256,0).or.
     &         find(a,'end if  ',256,0).or.
     &         find(a,'endselect ',256,0).or.
     &         find(a,'end select ',256,0).or.
     &         find(a,'endforall ',256,0).or.
     &         find(a,'end forall ',256,0).or.
     &         find(a,'endforall ',256,0).or.
     &         find(a,'end where ',256,0).or.
     &         find(a,'endwhere ',256,0))then
          i3=i3-1
          if(InElse.ne.0)then
            call Errr('Missing then in previous else',form,fout,b)
            InElse=0
          endif
        elseif(find(a,'end  ',256,0).or.
     &         find(a,'end function ',256,0).or.
     &         find(a,'endfunction ',256,0).or.
     &         find(a,'end subroutine ',256,0).or.
     &         find(a,'endsubroutine ',256,0).or.
     &         find(a,'end program ',256,0).or.
     &         find(a,'endprogram ',256,0).or.
     &         find(a,'end block',256,0).or.
     &         find(a,'endblock',256,0))then
          i3=i3-1
          InSub=InSub-1
          if(InSub.lt.0.or.(InSub.gt.0.and.InMod.le.0))then
            if(InSub.lt.0.and.InMod.gt.0.and.find(a,'end  ',256,0))then
              InSub=0
              InMod=InMod-1
            else
              call Errr('Invalid Diagramming Index',form,fout,b)
            endif
          endif
          if(i3.eq.0)InSub=0
        elseif(find(a,'elseif',128+256,0).or.
     &         find(a,'else if',128+256,0))then
          i4=max(i4,1)
          if(InElse.ne.0)then
            call Errr('Missing then in previous else',form,fout,b)
            InElse=0
          endif
          if(.not.find(a,'then  ',8,0))InElse=1
        elseif(find(a,'then  ',8,0))then
          if(InElse.eq.0)then
            i2=i2+1
            i3=i3+1
            i4=max(i4,1)
          endif
          InElse=0
        elseif( find(a,'selectcase',256,0).or.
     &          find(a,'select case',256,0))then
          i2=i2+1
          i3=i3+1
          i4=max(i4,1)
        elseif(find(a,'else  ',     256,0).or.
     &         find(a,'entry ',     4,  0).or.
     &         find(a,'case ',      256,0).or.
     &         find(a,'case(',      256,0).or.
     &         find(a,'contains ' , 2,  0).or.
     &         find(a,'elsewhere ', 256,0).or.
     &         find(a,'else where ',256,0))then
          if(find(a,'contains ',2,0))then
            if(fout)print*,'Line ',form,' ',b(1:LenA(b))
            InMod=InMod+1
          endif
          i4=max(i4,1)
        elseif( find(a,'selectcase',     256,0).or.
     &          find(a,'select case',    256,0).or.
     &          find(a,'for all (',      256,0).or.
     &          find(a,'forall (',       256,0).or.
     &          find(a,'for all(',       256,0).or.
     &          find(a,'forall(',        256,0).or.
     &          find(a,'do concurrent (',256,0).or.
     &          find(a,'do concurrent(', 256,0).or.
     &          find(a,'doconcurrent (', 256,0).or.
     &          find(a,'doconcurrent(',  256,0))then
          i2=i2+1
          i3=i3+1
          i4=max(i4,1)
        elseif( find(a,'where (',256,0).or.
     &          find(a,'where(', 256,0))then
          if(find(a,'(',0,0))iCol=iCol
          iCntParen=1
          do i=iCol,LenA(a)
            if(a(i:i).eq.'(')iCntParen=iCntParen+1
            if(a(i:i).eq.')')iCntParen=iCntParen-1
            if(iCntParen.eq.0)then
              if(a(i:5000).eq.')')then
                i2=i2+1
                i3=i3+1
                i4=max(i4,1)
              endif
              goto 20
            endif
          enddo
        elseif((find(a,'module ',         2,iDeclare).and.
     &     .not.find(a,'module procedure',2,iDeclare)).or.
     &          find(a,'interface ',      2,iDeclare).or.
     &         (find(a,'type ',           2,iDeclare).and.
     &     .not.find(a,'(',               0,iDeclare)).or.
     &         (find(a,'type,',           2,iDeclare).and.
     &     .not.find(a,'(',               0,iDeclare)))then
          if(fout)print*,'Line ',form,' ',b(1:LenA(b))
          i2=i2+1
          i3=i3+1
          i4=max(i4,1)
          Main1=0
          if(find(a,'module ',2,iDeclare).and.InMod.ne.0)
     &     call Errr('Nested modules',form,fout,b)
          InMod=InMod+1
        elseif(find(a,'do while',128+256,0).or.
     &         find(a,'dowhile', 128+256,0))then
          i2=i2+1
          i3=i3+1
          i4=max(i4,1)
          nlabel=min(100,nlabel+1)
          label(nlabel)='####'
        elseif(find(a,' do ',256,0).or.
     &   (iFree.eq.1.and.a(1:3).eq.'do '))then
          if(iFree.eq.1.and.a(1:3).eq.'do ')iCol=4
          if(iCol1.lt.7.or.a(7:max(7,iCol1)).eq.' '.or.
     &     (iFree.eq.1.and.a(1:3).eq.'do '))then
            i2=i2+1
            i3=i3+1
            i4=max(i4,1)
            iCol2=iCol
            dowhile(iCol2.lt.5000.and.a(iCol2:iCol2).ge.'0'.and.
     &       a(iCol2:iCol2).le.'9')
              iCol2=iCol2+1
            enddo
            iCol2=iCol2-1
            nlabel=min(100,nlabel+1)
            if(iCol2.ge.iCol)then
              label(nlabel)=a(iCol:iCol2)
            else
              label(nlabel)='####'
            endif
          endif
        elseif(find(a,': do ',0,0).or.find(a,':do ',0,0))then
          i2=i2+1
          i3=i3+1
          i4=max(i4,1)
        elseif(find(a,'function ',  4,iDeclare).or.
     &         find(a,'subroutine ',4,iDeclare).or.
     &         find(a,'program ',   2,iDeclare) .or.
     &         find(a,'block data ',2,iDeclare).or.
     &         find(a,'blockdata ', 2,iDeclare))then
          if(fout)print*,'Line ',form,' ',b(1:LenA(b))
          if(InSub.ne.0.and.InMod.eq.0)
     &     call Errr('Routine inside routine',form,fout,b)
          Main1=0
          InSub=InSub+1
          i2=i2+1
          i3=i3+1
          i4=max(i4,1)
          if(InSub.eq.1.and.i3.ne.1.and.InMod.le.0)then
            call Errr('invalid diagramming index',form,fout,b)
            i3=1
          endif
        endif
20      if(Main1.ne.0)then                      ! Was start of mainline
          if(fout)print*,   'Line ',form,' ',b(1:LenA(b))
          if(fout)write(8,*)'Line ',form,' ',b(1:LenA(b))
          if(nMain.gt.0)
     &     call Errr('Too many mainlines',form,fout,b)
          InSub=InSub+1
          nMain=nMain+1
          i2=i2+1
          i3=i3+1
          i4=max(i4,1)
        endif
 
21      if(a(1:5).ne.' '.or.iFree.eq.1)then     ! Search for DO labels
          istart=1
          dowhile(istart.lt.5000.and.a(istart:istart).eq.' ')
            istart=istart+1
          enddo
          iend=istart
          dowhile(iend.lt.5000.and.
     &     (a(iend:iend).ge.'0'.and.a(iend:iend).le.'9'))
            iend=iend+1
          enddo
          iend=iend-1
          if(iend.ge.1.and.a(1:max(1,iend)).ne.' ')then
            do i=1,nlabel
              j=nlabel+1-i                      !  (in reverse order)
              if(a(istart:iend).eq.label(j))then
                i3=i3-1
                nlabel=max(0,j-1)
                goto 21
              endif
            enddo
          endif
        endif
 
        if(AfterSemi.ne.' ')then
          a=AfterSemi
          goto 16
        endif
         
                                                ! Output formatted line
        nColPre=0
        i1pp=0
        i2pp=0
        i3pp=0
        i4pp=0
        call FormLine(b,fout,nColPre,i1,i2,i3,i4, 
     &   i1pp,i2pp,i3pp,i4pp,igoto,LCol,form,icomment,icomment2,
     &   icomment3,iGraphics)
 
        goto 10
 
99      if(iunit.eq.3)then
          iunit=1
          i1=i1-1
          close(3)
          nLine=nLinesave
          goto 10
        endif
        if(i3.gt.0.or.InSub.ne.0)
     &   call Errr('Some nest levels left hanging at end',form,fout,b)
        end
