#                     ---diagramf.sh---

# Unix/Linux/Cygwin bash shell procedure to diagram 
# card format Fortran language source code programs. 

# Usage:
#     diagramf.sh filename(s)
# to append diagram of the file(s) to diagram.out

# Note--This does not delete diagram.out before appending to it.
# I assume that the executable and this procedure are in your search path,
# and that they both have execute permission. 
# I also assume noclobber has not been set.

# Written by Mitchell R Grunes.
#  for his own and other's use, written in his own time

# Utilities for this and other languages and plastforms are documented at
#   http://mgrunes.com/diagram/index.html

for f in $*
do

  echo ========================-- "$1" --========================
# Prompt answers: input from $1, output to diagram2.sc (for now),
# place numbers in column 73, embed include files, don't use free
# format but warn if functional line goes past col 72,
# warn if total line goes past 132, don't use IBM PC graphics

  echo "$1"        >  diagram.sc
  echo diagram2.sc >> diagram.sc
  echo 73          >> diagram.sc
  echo 1           >> diagram.sc
  echo 0           >> diagram.sc
  echo 132         >> diagram.sc
  echo 0           >> diagram.sc

  diagramf < diagram.sc

  cat diagram2.sc >> diagram.out
  rm -f diagram.sc
  rm -f diagram2.sc

done

