#                     ---diagrami.sh---

# Unix/Linux/Cygwin bash shell procedure to diagram 
# IDL, PV-WAVE, GDL and FL language source code programs. 

# Usage:
#     diagrami.sh filename(s)
# to append diagram of the file(s) to diagram.out

# Note--This does not delete diagram.out before appending to it.
# I assume that the executable and this procedure are in your search path,
# and that they both have execute permission. 
# I also assume noclobber has not been set.

# Written by Mitchell R Grunes.
#  for his own and other's use, written in his own time

# Utilities for this and other languages and plastforms are documented at
#   http://mgrunes.com/diagram/index.html

for f in $*
do

  echo ========================-- "$f" --========================
  #Prompt answers: input from $f, output to diagram2.sc (for now),
  # Place line numbers in column 80, don't use IBM PC graphics,
  # don't warn if end ends endif, etc., warn of lines over 160 cols,
  # don't warn of unclosed quotes

  echo "$f"        >  diagram.sc
  echo diagram2.sc >> diagram.sc
  echo 80          >> diagram.sc
  echo 0           >> diagram.sc
  echo 0           >> diagram.sc
  echo 160         >> diagram.sc
  echo 0           >> diagram.sc

  diagrami < diagram.sc

  cat diagram2.sc >> diagram.out
  rm -f diagram.sc
  rm -f diagram2.sc

done

