c This attempt to extract source code from diagrammed
c  programs created by diagramc, diagramf, diagramh, diagrami and diagramx.
c Program by Mitchell R Grunes.
c Revision date: 6/17/2020.
c This program was written in FORTRAN, for historic reasons.
 
c-----------------------------------------------------------------------
        function LenA(a)                        ! Length of string, at least 1
c Program by Mitchell R Grunes.
c Revision date: 5/15/2017.
        character*(*) a
        n=len(a)
        dowhile(n.gt.1.and.a(n:n).eq.' ')
          n=n-1
        enddo
        LenA=n
        end
c-----------------------------------------------------------------------
        character*5000 function aRd(a)          ! Read prompted string from stdin.
                                                ! Echo result to standard output.
                                                ! Used for filenames.
c Program by Mitchell R Grunes.
c Revision date: 5/15/2017.
        character*(*)  a
        character*5000 b
        print*,a(1:len(a))//':'
        b=' '
        read(*,'(100(100a1))')(b(i:i),i=1,5000)
        print*,b(1:lenA(b))
        aRd=b
        return
        end
c-----------------------------------------------------------------------
        subroutine Warn(Message,form,fout,a)            ! Issue a warning
c Program by Mitchell R Grunes.
c Revision date: 6/17/2020.
        character*(*) Message
        character*(*) form
        logical fout
        character*5000 a
        if(fout)write(2,*)'***WARNING ',Message,': Line ',
     &   form(1:lenA(form)),':'
                print*,   '***WARNING ',Message,': Line ',
     &   form(1:lenA(form)),':'
        if(fout)print*,a(1:LenA(a))
        print*,char(7)
        end
c-----------------------------------------------------------------------
        Function iRdLin(iUnit,fOut,MaxL,a,nLine,form)! Read line from input file...
                                                ! Function returns Returns non-zero
                                                !  at end of file.
                                                ! Handle form feeds, expand tabs,
                                                !  and drop non-ascii characters.
        ! --- Inputs --
        integer iUnit                           ! File unit #
        logical fOut                            ! .true. if outputing to a file.
        integer MaxL                            ! Length over which should issue warning.
        ! --- Outputs --
        character*5000 a                        ! The output line.
        character*5    form                     ! Output formatted line #.
        ! --- Input and Output ---
        integer nLine                          ! Line number -- incremented
 
c Program by Mitchell R Grunes.
c Revision date: 5/15/2017.
 
        character*5000 b
 
        a=' '
        read(iUnit,'(100(100a1))',end=99)(a(i:i),i=1,5000)
        nLine=nLine+1
 
        b=' '                                   ! Format line #
        write(b,'(i5)')nLine
        form=b
 
        if(a(1:1).eq.char(12))then
          if(fout)write(2,'(a1,:)')char(12)
          if(.not.fout)print*,'------------FORM FEED------------'
          a=a(2:5000)
        endif
 
        b=' '                                   ! Expand tabs to spaces,
                                                ! Drop non-ascii characters.
        i2Long=0                                ! not yet marked too long
        iLong=0                                 ! not yet marked long
        j=1                                     ! Output Column #
        do i=1,LenA(a)
          if(a(i:i).eq.char(9))then             ! char(9) is tab
            j=(j-1)/8*8+8+1
                                                ! Ascii printable characters
                                                ! are between ' ' and char(128)
          elseif(a(i:i).ge.' '.and.a(i:i).lt.char(128))then
            if(j.le.5000)b(j:j)=a(i:i)
            j=j+1
            if(a(i:i).ne.' '.and.j.ge.5000-10.and.i2Long.eq.0)then
              call Warn('Line too long to undiagram',form,fout,a)
              i2Long=1
            elseif(a(i:i).ne.' '.and.j.gt.MaxL.and.iLong.eq.0)then
              call Warn('Line over warning length',form,fout,a)
              iLong=1
            endif
          endif
        enddo
        a=b
 
        iRdLin=0
        return
 
99      iRdLin=1
        end
c-----------------------------------------------------------------------
        program undiagram
c This attempt to extract source code from diagrammed
c  programs created by diagramc, diagramf, diagramh and diagrami.
 
c Program by Mitchell R Grunes.
c Revision date: 5/15/2017.
 
c Note that this leaves the headers consisting of the following 3 lines:
c  <formfeed>=============--<filenames>--=============
c  ....,....1....,....2....,....3....,....4....,....5....,....6....,....7....,....8
c  filename
c lines, (and the following blank lines) but prints a warning on the screen.
 
c It also hasn't been extensively tested.
 
c See http://mgrunes.com/diagram/index.html for more info.
 
        character*5000 FilNam,aRd
        character*5000 Line
        character*1   c,c1,c2,c3,c4,c5
 
 
        character*5 form                        ! Output formatted line #--not used.
 
        FilNam=aRd('Input file (with diagrammed code)')
        open(1,file=FilNam,status='old')
 
        FilNam=aRd('Output file (with undiagrammed code)')
        open(2,file=FilNam)
 

        NumCol=0                                ! column of |

        nLine=0
        iUnit=1                                 ! Read line from input file...
        MaxL=5000
        iFirst=5000
1       if(iRdLin(iUnit,.false.,MaxL,Line,nLine,form).ne.0)goto 99

        if(nLine.eq.1)then
          print*,'First input line:'
          print*,'Col '//'....,....1....,....2....,....3....,....4'//
     &                   '....,....5....,....6....,....7....,....8'//
     &                   '....,....9....,....0....,....1....,....2'//
     &                   '....,....3'
          print*,'    '//Line(1:LenA(line))
          print*,''
          print*,'Column to start at:'
          print*,'Use column of comment or label mark.'
          print*,' If there is none, pick 2 for now.'
          print*,' If get an error or suggestion, then'
          print*,'  run this again, with the right #.'
          print*,'Column to start at:'
          read*,iStart
          iStart=max(iStart,2)
        endif
 
        i=LenA(Line)+1-3
        dowhile (NumCol.eq.0.and.i.gt.2)       ! Find column of ending |####
          i=i-1
          c1=Line(i:i)
          c2=Line(i+1:i+1)
          c3=Line(i+2:i+2)
          c4=Line(i+3:i+3)
          c5=Line(i+4:i+4)
          if( (c1.eq.'|'.or.c1.eq.char(179).or.c1.eq.char(186)).and.
     &        (c2.eq.' '.or.(c2.ge.'0'.and.c2.le.'9')).and.
     &        (c3.eq.' '.or.(c3.ge.'0'.and.c3.le.'9')).and.
     &        (c4.eq.' '.or.(c4.ge.'0'.and.c4.le.'9')).and.
     &        (             (c5.ge.'0'.and.c5.le.'9')).and.
     &        Line(i+5:5000).eq.' ')then
            NumCol=i
c           print*,'| column = ',NumCol,' from line ',nLine
          endif
        enddo
 
        if(NumCol.gt.0)then                   ! Remove trailing | #### field.
          i=NumCol
          if(i.lt.5000-5)then
            c1=Line(i:i)
            c2=Line(i+1:i+1)
            c3=Line(i+2:i+2)
            c4=Line(i+3:i+3)
            c5=Line(i+4:i+4)
            if( (c1.eq.'|'.or.c1.eq.char(179).or.c1.eq.char(186)).and.
     &          (c2.eq.' '.or.(c2.ge.'0'.and.c2.le.'9')).and.
     &          (c3.eq.' '.or.(c3.ge.'0'.and.c3.le.'9')).and.
     &          (c4.eq.' '.or.(c4.ge.'0'.and.c4.le.'9')).and.
     &          (             (c5.ge.'0'.and.c5.le.'9')).and.
     &          Line(i+5:5000).eq.' ')
     &       Line(i:5000)=' '
          endif
        endif
 
        i=iStart-1                             ! Replace diagram marks at start with space
        c=' '
        dowhile((c.eq.' '.or.c.eq.'+'.or.c.eq.'-'.or.
     &          c.eq.'|'.or.c.eq.'*'.or.c.eq.'/'.or.c.eq.'\'.or.
     &          c.eq.char(218).or.c.eq.char(192).or.c.eq.char(195).or.
     &          c.eq.char(179).or.c.eq.char(196).or.c.eq.char(194).or.
     &          c.eq.char(193).or.c.eq.char(197).or.c.eq.char(214).or.
     &          c.eq.char(211).or.c.eq.char(199).or.c.eq.char(186).or.
     &          c.eq.char(196).or.c.eq.char(209).or.c.eq.char(208)).and.
     &          i.lt.5000)
          i=i+1
          c=Line(i:i)
        enddo
        iSkip=i-1
        if(i.lt.1.or.i.gt.5000)then
          iSkip=iStart-1
        else
          iFirst=min(iFirst,i)
        endif
        if(iSkip.ge.1)Line(1:iSkip)=' '

        if(Line(1:Max(1,iStart-1)).eq.' ')then          
          Line=Line(iStart:5000)
        else
          print*,'***ERROR: Need larger Start, line ',nLine
          print*,'Col ....,....1....,....2....,....3....,....4'
          print*,'    '//Line(1:LenA(line))
          print*,char(7)
          print*,'Oops: Maybe Start col should be ',iSkip+1
          stop
        endif
 
        if(nLine.eq.1)then
          print*,'Output lines'
          print*,'Col '//'....,....1....,....2....,....3....,....4'
        endif
        print*,  '    '//Line(1:LenA(line))
        write(2,'(100(100a1))')(Line(i:i),i=1,LenA(Line))
        goto 1
 
99      if(iFirst.gt.1.and.iFirst.lt.5000.and.iFirst.gt.iStart)then
          print*,'***Suggestion:'
          print*,'First used non-blank input col was ',iFirst
          print*,'Maybe we should have picked that as Start!'
        endif
        end
